#include <math.h>

double getReferenceTwistOPT (
  double *undefMatTanRB,
  double *undefMatNorRB,
  double *undefRefTanRO,
  double *undefRefNorRO,
  double rtx,
  double *rotationAnglesRB,
  double *ex)
{
  double t1;
  double t10;
  double t102;
  double t105;
  double t107;
  double t109;
  double t111;
  double t114;
  double t116;
  double t117;
  double t118;
  double t12;
  double t120;
  double t122;
  double t124;
  double t130;
  double t134;
  double t14;
  double t140;
  double t144;
  double t150;
  double t157;
  double t159;
  double t16;
  double t161;
  double t166;
  double t173;
  double t178;
  double t18;
  double t187;
  double t190;
  double t196;
  double t2;
  double t20;
  double t211;
  double t22;
  double t227;
  double t23;
  double t234;
  double t24;
  double t3;
  double t30;
  double t31;
  double t37;
  double t38;
  double t4;
  double t46;
  double t5;
  double t51;
  double t53;
  double t56;
  double t6;
  double t61;
  double t65;
  double t66;
  double t67;
  double t68;
  double t69;
  double t70;
  double t71;
  double t73;
  double t74;
  double t75;
  double t76;
  double t78;
  double t79;
  double t8;
  double t81;
  double t82;
  double t86;
  double t87;
  double t9;
  double t90;
  double t92;
  double t93;
  double t95;
  double t98;
  t1 = ex[0];
  t2 = t1 * t1;
  t3 = ex[1];
  t4 = t3 * t3;
  t5 = ex[2];
  t6 = t5 * t5;
  t8 = sqrt(t2 + t4 + t6);
  t9 = 0.1e1 / t8;
  t10 = t9 * t3;
  t12 = undefRefTanRO[0] * t9;
  t14 = 0.1e1 * t12 * t1;
  t16 = undefRefTanRO[1] * t9;
  t18 = 0.1e1 * t16 * t3;
  t20 = undefRefTanRO[2] * t9;
  t22 = 0.1e1 * t20 * t5;
  t23 = t14 + t18 + t22;
  t24 = undefRefNorRO[2];
  t30 = 0.1e1 * t16 * t5 - 0.1e1 * t20 * t3;
  t31 = undefRefNorRO[1];
  t37 = 0.1e1 * t20 * t1 - 0.1e1 * t12 * t5;
  t38 = undefRefNorRO[0];
  t46 = 0.1e1 * t12 * t3 - 0.1e1 * t16 * t1;
  t51 = (t30 * t38 + t37 * t31 + t46 * t24) / (0.1e1 + t14 + t18 + t22);
  t53 = t23 * t24 + t30 * t31 - t37 * t38 + t51 * t46;
  t56 = t9 * t5;
  t61 = t23 * t31 + t46 * t38 - t30 * t24 + t51 * t37;
  t65 = cos(rtx);
  t66 = rotationAnglesRB[2];
  t67 = cos(t66);
  t68 = rotationAnglesRB[1];
  t69 = cos(t68);
  t70 = t67 * t69;
  t71 = undefMatTanRB[0];
  t73 = sin(t68);
  t74 = t67 * t73;
  t75 = rotationAnglesRB[0];
  t76 = sin(t75);
  t78 = sin(t66);
  t79 = cos(t75);
  t81 = t74 * t76 - t78 * t79;
  t82 = undefMatTanRB[1];
  t86 = t74 * t79 + t78 * t76;
  t87 = undefMatTanRB[2];
  t90 = (t70 * t71 + t81 * t82 + t86 * t87) * t9;
  t92 = 0.1e1 * t90 * t1;
  t93 = t78 * t69;
  t95 = t78 * t73;
  t98 = t95 * t76 + t67 * t79;
  t102 = t95 * t79 - t67 * t76;
  t105 = (t93 * t71 + t98 * t82 + t102 * t87) * t9;
  t107 = 0.1e1 * t105 * t3;
  t109 = t69 * t76;
  t111 = t69 * t79;
  t114 = (-t73 * t71 + t109 * t82 + t111 * t87) * t9;
  t116 = 0.1e1 * t114 * t5;
  t117 = t92 + t107 + t116;
  t118 = undefMatNorRB[0];
  t120 = undefMatNorRB[1];
  t122 = undefMatNorRB[2];
  t124 = t70 * t118 + t81 * t120 + t86 * t122;
  t130 = 0.1e1 * t114 * t1 - 0.1e1 * t90 * t5;
  t134 = -t73 * t118 + t109 * t120 + t111 * t122;
  t140 = 0.1e1 * t90 * t3 - 0.1e1 * t105 * t1;
  t144 = t93 * t118 + t98 * t120 + t122 * t102;
  t150 = 0.1e1 * t105 * t5 - 0.1e1 * t114 * t3;
  t157 = (t150 * t124 + t130 * t144 + t140 * t134) / (0.1e1 + t92 + t107 + t116);
  t159 = t117 * t124 + t130 * t134 - t140 * t144 + t157 * t150;
  t161 = sin(rtx);
  t166 = t117 * t134 + t150 * t144 - t130 * t124 + t157 * t140;
  t173 = t117 * t144 + t140 * t124 - t150 * t134 + t157 * t130;
  t178 = t9 * t1;
  t187 = (0.1e1 * t178 * t159 + 0.1e1 * t10 * t173 + 0.1e1 * t56 * t166) * (0.1e1 - t65);
  t190 = t65 * t159 + t161 * (0.1e1 * t10 * t166 - 0.1e1 * t56 * t173) + 0.1e1 * t187 * t178;
  t196 = t23 * t38 + t37 * t24 - t46 * t31 + t51 * t30;
  t211 = t65 * t173 + t161 * (0.1e1 * t56 * t159 - 0.1e1 * t178 * t166) + 0.1e1 * t187 * t10;
  t227 = t65 * t166 + t161 * (0.1e1 * t178 * t173 - 0.1e1 * t10 * t159) + 0.1e1 * t187 * t56;
  t234 = atan2((0.1e1 * t10 * t53 - 0.1e1 * t56 * t61) * t190 + (0.1e1 * t56 * t196 - 0.1e1 * t178 * t53) * t211 + (0.1e1 * t178 * t61 - 0.1e1 * t10 * t196) * t227, t196 * t190 + t61 * t211 + t53 * t227);
  return(-t234);
}
